<?php
$daysInWeek = 7;
$firstDOW = 0;
$calLang = "en";
$fillBlanks = false;

function dayName($day, $lang, $type)
{
 switch($lang)
 {
  case "en":
   switch($type)
   {
    case "a":
     switch($day)
     {
      case 0:
       $dayName = "Sun";
       break;
      case 1:
       $dayName = "Mon";
       break;
      case 2:
       $dayName = "Tue";
       break;
      case 3:
       $dayName = "Wed";
       break;
      case 4:
       $dayName = "Thu";
       break;
      case 5:
       $dayName = "Fri";
       break;
      case 6:
       $dayName = "Sat";
       break;
      default:
       $dayName = "Invalid day number!";
       break;
     }
     break;
    case "s":
     switch($day)
     {
      case 0:
       $dayName = "S";
       break;
      case 1:
       $dayName = "M";
       break;
      case 2:
       $dayName = "T";
       break;
      case 3:
       $dayName = "W";
       break;
      case 4:
       $dayName = "T";
       break;
      case 5:
       $dayName = "F";
       break;
      case 6:
       $dayName = "S";
       break;
      default:
       $dayName = "Invalid day number!";
       break;
     }
     break;
    case "d":
     switch($day)
     {
      case 0:
       $dayName = "Su";
       break;
      case 1:
       $dayName = "Mo";
       break;
      case 2:
       $dayName = "Tu";
       break;
      case 3:
       $dayName = "We";
       break;
      case 4:
       $dayName = "Th";
       break;
      case 5:
       $dayName = "Fr";
       break;
      case 6:
       $dayName = "Sa";
       break;
      default:
       $dayName = "Invalid day number!";
       break;
     }
     break;
    case "f":
     switch($day)
     {
      case 0:
       $dayName = "Sunday";
       break;
      case 1:
       $dayName = "Monday";
       break;
      case 2:
       $dayName = "Tuesday";
       break;
      case 3:
       $dayName = "Wednesday";
       break;
      case 4:
       $dayName = "Thursday";
       break;
      case 5:
       $dayName = "Friday";
       break;
      case 6:
       $dayName = "Saturday";
       break;
      default:
       $dayName = "Invalid day number!";
       break;
     }
     break;
   }
   break;
  case "es":
   switch($type)
   {
    case "a":
     switch($day)
     {
      case 0:
       $dayName = "Dom";
       break;
      case 1:
       $dayName = "Lun";
       break;
      case 2:
       $dayName = "Mar";
       break;
      case 3:
       $dayName = "Mié";
       break;
      case 4:
       $dayName = "Jue";
       break;
      case 5:
       $dayName = "Vie";
       break;
      case 6:
       $dayName = "Sáb";
       break;
      default:
       $dayName = "Invalid day number!";
       break;
     }
     break;
    case "s":
     switch($day)
     {
      case 0:
       $dayName = "D";
       break;
      case 1:
       $dayName = "L";
       break;
      case 2:
       $dayName = "M";
       break;
      case 3:
       $dayName = "X";
       break;
      case 4:
       $dayName = "J";
       break;
      case 5:
       $dayName = "V";
       break;
      case 6:
       $dayName = "S";
       break;
      default:
       $dayName = "Invalid day number!";
       break;
     }
     break;
    case "d":
     switch($day)
     {
      case 0:
       $dayName = "Do";
       break;
      case 1:
       $dayName = "Lu";
       break;
      case 2:
       $dayName = "Ma";
       break;
      case 3:
       $dayName = "Mi";
       break;
      case 4:
       $dayName = "Ju";
       break;
      case 5:
       $dayName = "Vi";
       break;
      case 6:
       $dayName = "Sa";
       break;
      default:
       $dayName = "Invalid day number!";
       break;
     }
     break;
    case "f":
     switch($day)
     {
      case 0:
       $dayName = "Domingo";
       break;
      case 1:
       $dayName = "Lunes";
       break;
      case 2:
       $dayName = "Martes";
       break;
      case 3:
       $dayName = "Miércoles";
       break;
      case 4:
       $dayName = "Jueves";
       break;
      case 5:
       $dayName = "Viernes";
       break;
      case 6:
       $dayName = "Sábado";
       break;
      default:
       $dayName = "Invalid day number!";
       break;
     }
     break;
   }
  default:
   $dayName = "Invalid language!";
   break;
 }
 return $dayName;
}

function monthName($month, $lang, $type)
{
 switch($lang)
 {
  case "en":
   switch($type)
   {
    case "a":
     switch($month)
     {
      case 1:
       $monthName = "Jan";
       break;
      case 2:
       $monthName = "Feb";
       break;
      case 3:
       $monthName = "Mar";
       break;
      case 4:
       $monthName = "Apr";
       break;
      case 5:
       $monthName = "May";
       break;
      case 6:
       $monthName = "Jun";
       break;
      case 7:
       $monthName = "Jul";
       break;
      case 8:
       $monthName = "Aug";
       break;
      case 9:
       $monthName = "Sep";
       break;
      case 10:
       $monthName = "Oct";
       break;
      case 11:
       $monthName = "Nov";
       break;
      case 12:
       $monthName = "Dec";
       break;
      default:
       $monthName = "Invalid month number!";
       break;
     }
     break;
    case "f":
     switch($month)
     {
      case 1:
       $monthName = "January";
       break;
      case 2:
       $monthName = "February";
       break;
      case 3:
       $monthName = "March";
       break;
      case 4:
       $monthName = "April";
       break;
      case 5:
       $monthName = "May";
       break;
      case 6:
       $monthName = "June";
       break;
      case 7:
       $monthName = "July";
       break;
      case 8:
       $monthName = "August";
       break;
      case 9:
       $monthName = "September";
       break;
      case 10:
       $monthName = "October";
       break;
      case 11:
       $monthName = "November";
       break;
      case 12:
       $monthName = "December";
       break;
      default:
       $monthName = "Invalid month number!";
       break;
     }
   }
   break;
  case "es":
   switch($type)
   {
    case "a":
     switch($month)
     {
      case 1:
       $monthName = "Enero";
       break;
      case 2:
       $monthName = "Feb";
       break;
      case 3:
       $monthName = "Mar";
       break;
      case 4:
       $monthName = "Abr";
       break;
      case 5:
       $monthName = "Mayo";
       break;
      case 6:
       $monthName = "Jun";
       break;
      case 7:
       $monthName = "Jul";
       break;
      case 8:
       $monthName = "Agosto";
       break;
      case 9:
       $monthName = "Set";
       break;
      case 10:
       $monthName = "Oct";
       break;
      case 11:
       $monthName = "Nov";
       break;
      case 12:
       $monthName = "Dic";
       break;
      default:
       $monthName = "Invalid month number!";
       break;
     }
     break;
    case "f":
     switch($month)
     {
      case 1:
       $monthName = "Enero";
       break;
      case 2:
       $monthName = "Febrero";
       break;
      case 3:
       $monthName = "Marzo";
       break;
      case 4:
       $monthName = "Abril";
       break;
      case 5:
       $monthName = "Mayo";
       break;
      case 6:
       $monthName = "Junio";
       break;
      case 7:
       $monthName = "Julio";
       break;
      case 8:
       $monthName = "Agosto";
       break;
      case 9:
       $monthName = "Septiembre";
       break;
      case 10:
       $monthName = "Octubre";
       break;
      case 11:
       $monthName = "Noviembre";
       break;
      case 12:
       $monthName = "Diciembre";
       break;
      default:
       $monthName = "Invalid month number!";
       break;
     }
   }
  default:
   $dayName = "Invalid language!";
   break;
 }
 return $monthName;
}

if(isset($_POST))
{
 if(isset($_POST["nextMonth"]))
 {
  $_POST["currentMonth"] += 1;
  if(+$_POST["currentMonth"] > 12)
  {
   $_POST["currentYear"] += 1;
   $_POST["currentMonth"] = 1;
  }
 }
 if(isset($_POST["nextYear"]))
 {
  $_POST["currentYear"] += 1;
 }
 if(isset($_POST["prevMonth"]))
 {
  $_POST["currentMonth"] -= 1;
  if(+$_POST["currentMonth"] < 1)
  {
   $_POST["currentYear"] -= 1;
   $_POST["currentMonth"] = 12;
  }
 }
 if(isset($_POST["prevYear"]))
 {
  $_POST["currentYear"] -= 1;
 }
}
$_POST["currentMonth"] = empty($_POST["currentMonth"]) ? date("m") : $_POST["currentMonth"];
$month = $_POST["currentMonth"];
$_POST["currentYear"] = empty($_POST["currentYear"]) ? date("Y") : $_POST["currentYear"];
$year = $_POST["currentYear"];
// set cDate to 1st of month
$cDate = new DateTime("{$year}-{$month}-1");
// get last day of cDate
$daysInMonth = $cDate->format("t");
// get 1st of cDate DOW (0 - 6)
$startDOW = $cDate->format("w");
// convert $startDOW based on $firstDOW
$sDOW = ($startDOW - $firstDOW) % $daysInWeek;
$sDOW = $sDOW < 0 ? (($sDOW + $daysInWeek) % $daysInWeek) : $sDOW;
// set eDate to end of the month
$eDate = new DateTime("{$year}-{$month}-{$daysInMonth}");
// get last day of current month DOW (0 - 6)
$endDOW = $eDate->format("w");
// convert $endDOW based on $firstDOW
$eDOW = ($endDOW - $firstDOW) % $daysInWeek;
$eDOW = $eDOW < 0 ? (($daysInWeek + $eDOW) % $daysInWeek) : $eDOW;
// calculate first day of calendar, before 1st day of the month
if($sDOW == 4)
{
 $sTmp = -($daysInWeek - $sDOW + 1);
}
else
{
 $sTmp = -$sDOW;
}
// check first character, if not '-' add "+' in front
$sTmp = substr($sTmp, 0, 1) != "-" ? "+" . $sTmp : $sTmp;
// set current month to start of calendar week
$sDate = $cDate->modify( "{$sTmp} day" );
// set eDate to end of month
$eDate = new DateTime("{$year}-{$month}-{$daysInMonth}");
// calculate last day of calendar, after end of the month
$sTmp = ($daysInWeek - $eDOW - 1);
$sTmp = substr($sTmp, 0, 1) != "-" ? "+" . $sTmp : $sTmp;
// set current month to end of calendar, after last day of the month
$eDate = $eDate->modify( "{$sTmp} day" );
$counter = 0;
?>
<!DOCTYPE HTML>
<html lang="en">
<head>
 <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
 <meta name="author" content="Charles E. Finkenbiner - Creative Electronic Formulas, Inc.">
 <meta name="generator" content="SynWrite 6.40.2770">
 <meta name="viewport" content="width=device-width">
	<title>Calendar</title>
 <link rel="shortcut icon" href="calendar.ico">
 <link rel="stylesheet" type="text/css" href="calendar.css">
<script>
document.addEventListener("DOMContentLoaded", domReady);
window.addEventListener("resize", onResize, true);
<?php echo("let firstDOW = {$firstDOW};" . PHP_EOL);?>
<?php echo("let daysInWeek = {$daysInWeek};" . PHP_EOL);?>
<?php echo("let calLang = \"{$calLang}\";" . PHP_EOL);?>

function dayNumberToName(day, clang, ctype)
{
 switch(clang.toLowerCase())
 {
  case "en":
   switch(ctype.toLowerCase())
   {
    case "a":
     switch(day)
     {
      case 0:
       dayName = "Sun";
       break;
      case 1:
       dayName = "Mon";
       break;
      case 2:
       dayName = "Tue";
       break;
      case 3:
       dayName = "Wed";
       break;
      case 4:
       dayName = "Thu";
       break;
      case 5:
       dayName = "Fri";
       break;
      case 6:
       dayName = "Sat";
       break;
      default:
       dayName = "Invalid day number!";
       break;
     }
     break;
    case "s":
     switch(day)
     {
      case 0:
       dayName = "S";
       break;
      case 1:
       dayName = "M";
       break;
      case 2:
       dayName = "T";
       break;
      case 3:
       dayName = "W";
       break;
      case 4:
       dayName = "T";
       break;
      case 5:
       dayName = "F";
       break;
      case 6:
       dayName = "S";
       break;
      default:
       dayName = "Invalid day number!";
       break;
     }
     break;
    case "d":
     switch(day)
     {
      case 0:
       dayName = "Su";
       break;
      case 1:
       dayName = "Mo";
       break;
      case 2:
       dayName = "Tu";
       break;
      case 3:
       dayName = "We";
       break;
      case 4:
       dayName = "Th";
       break;
      case 5:
       dayName = "Fr";
       break;
      case 6:
       dayName = "Sa";
       break;
      default:
       dayName = "Invalid day number!";
       break;
     }
     break;
    case "f":
     switch(day)
     {
      case 0:
       dayName = "Sunday";
       break;
      case 1:
       dayName = "Monday";
       break;
      case 2:
       dayName = "Tuesday";
       break;
      case 3:
       dayName = "Wednesday";
       break;
      case 4:
       dayName = "Thursday";
       break;
      case 5:
       dayName = "Friday";
       break;
      case 6:
       dayName = "Saturday";
       break;
      default:
       dayName = "Invalid day number!";
       break;
     }
     break;
   }
   break;
  case "es":
   switch(ctype.toLowerCase())
   {
    case "a":
     switch(day)
     {
      case 0:
       dayName = "Dom";
       break;
      case 1:
       dayName = "Lun";
       break;
      case 2:
       dayName = "Mar";
       break;
      case 3:
       dayName = "Mié";
       break;
      case 4:
       dayName = "Jue";
       break;
      case 5:
       dayName = "Vie";
       break;
      case 6:
       dayName = "Sáb";
       break;
      default:
       dayName = "Invalid day number!";
       break;
     }
     break;
    case "s":
     switch(day)
     {
      case 0:
       dayName = "D";
       break;
      case 1:
       dayName = "L";
       break;
      case 2:
       dayName = "M";
       break;
      case 3:
       dayName = "X";
       break;
      case 4:
       dayName = "J";
       break;
      case 5:
       dayName = "V";
       break;
      case 6:
       dayName = "S";
       break;
      default:
       dayName = "Invalid day number!";
       break;
     }
     break;
    case "d":
     switch(day)
     {
      case 0:
       dayName = "Do";
       break;
      case 1:
       dayName = "Lu";
       break;
      case 2:
       dayName = "Ma";
       break;
      case 3:
       dayName = "Mi";
       break;
      case 4:
       dayName = "Ju";
       break;
      case 5:
       dayName = "Vi";
       break;
      case 6:
       dayName = "Sa";
       break;
      default:
       dayName = "Invalid day number!";
       break;
     }
     break;
    case "f":
     switch(day)
     {
      case 0:
       dayName = "Domingo";
       break;
      case 1:
       dayName = "Lunes";
       break;
      case 2:
       dayName = "Martes";
       break;
      case 3:
       dayName = "Miércoles";
       break;
      case 4:
       dayName = "Jueves";
       break;
      case 5:
       dayName = "Viernes";
       break;
      case 6:
       dayName = "Sábado";
       break;
      default:
       dayName = "Invalid day number!";
       break;
     }
     break;
   }
   break;
  default:
   dayName = "Invalid language!";
   break;
 }
 return dayName;
}

function domReady()
{
 document.getElementById("currentMonth").focus();
 onResize();
}

function onResize()
{
 let ctype = null;
 if(window.innerWidth > 525)
 {
  ctype = "f";
 }
 if(window.innerWidth <= 525)
 {
  ctype = "a";
 }
 if(ctype)
 {
  let elem = document.getElementById("dow").cells;
  let fDOW = firstDOW;
  for(let day = 0; day < daysInWeek; day++)
  {
   let d = (fDOW) % daysInWeek;
   elem[day].innerHTML = dayNumberToName(d, calLang, ctype);
   fDOW++;
  }
 }
}

function onBlur(elem)
{
 if(elem.value != "" && elem.value >= 1)
 {
  document.getElementById("cefical").submit();
 }
 elem.focus();
 return false;
}

function onChange()
{
 let elem = document.getElementById("currentYear");
 if(elem.value != "" && elem.value >= 1)
 {
  document.getElementById("cefical").submit();
 }
 elem.focus();
 return false;
}
</script>
</head>
<body>
 <noscript><h6 style="background-color: red; color: white; height: 100%; text-align: center; padding: 25px; width: 100%;">Javascript is required!</h6></noscript>
 <form id="cefical" action="<?php echo($_SERVER['PHP_SELF']);?>" method="post" accept-charset="UTF-8">
  <input type="hidden" id="submitted" name="submitted" value="<?php echo(isset($_POST["submitted"]) ? $_POST["submitted"] : 1);?>">
  <input type="text" id="trap" name="trap" style="display: none;" value="">
  <table id="calendar">
   <thead>
    <tr style="line-height: 50px;">
     <th class="left">
      <input type="submit" id="prevYear" name="prevYear" value="&lt;&lt;" title="Previous Year">
     </th>
     <th class="left">
      <input type="submit" id="prevMonth" name="prevMonth" value="&lt;" title="Previous Month">
     </th>
     <th colspan="<?php echo($daysInWeek - 4);?>" class="middle">
      <select id="currentMonth" name="currentMonth" title="Current Month" onchange="javascript:onChange();">
<?php
if(!empty($month))
{
 for($mon = 1; $mon <= 12; $mon++)
 {
  echo("      <option value=\"{$mon}\"");
  if(isset($_POST["currentMonth"]))
  {
   if($mon == $_POST["currentMonth"])
   {
    echo(" selected=\"selected\"");
   }
  }
  echo(">" . monthName($mon, $calLang, "f") . "</option>" . PHP_EOL);
 }
}
?>
      </select>
      <input type="text" id="currentYear" name="currentYear" size="5" title="Current Year" value="<?php if(isset($_POST["currentYear"])) echo($_POST["currentYear"]);?>" onblur="javascript:onBlur(this)">
     </th>
     <th class="right">
      <input type="submit" id="nextMonth" name="nextMonth" value="&gt;" title="Next Month">
     </th>
     <th class="right">
      <input type="submit" id="nextYear" name="nextYear" value="&gt;&gt;" title="Next Year">
     </th>
    </tr>
    <tr id="dow" style="line-height: 30px;">
<?php
if(!empty($month))
{
 for($day = (0 + $firstDOW); $day < ($daysInWeek + $firstDOW); $day++)
 {
  echo("     <th class=\"dow\">" . dayName(($day % $daysInWeek), $calLang, "f") . "</th>" . PHP_EOL);
 }
}
?>
    </tr>
   </thead>
   <tbody>
<?php
if($sDate)
{
 echo("    <tr>" . PHP_EOL);
 while($sDate <= $eDate)
 {
  if($sDate->format("n") != $month)
  {
   if($fillBlanks)
   {
    echo("     <td class=\"day non\">" . $sDate->format("j") . "</td>" . PHP_EOL);
   }
   else
   {
    echo("     <td class=\"day\">&nbsp;</td>" . PHP_EOL);
   }
  }
  else
  {
   echo("     <td class=\"day date\">" . $sDate->format("j") . "</td>" . PHP_EOL);
  }
  $sDate = $sDate->modify( "+1 day" );
  $counter++;
  if(($counter > ($daysInWeek - 1)))
  {
   if($eDate < $sDate)
   {
    echo("    </tr>" . PHP_EOL);
   }
   else
   {
    echo("    </tr>" . PHP_EOL);
    echo("    <tr>" . PHP_EOL);
   }
   $counter = 0;
  }
 }
}
?>
   </tbody>
   <tfoot style="display: none;">
    <tr>
     <td colspan="<?php echo($daysInWeek);?>">Line 1</td>
    </tr>
   </tfoot>
  </table>
 </form>
 <div class="reset-l"></div>
 <script>
let elem = document.getElementById("currentYear");
elem.addEventListener("keydown", ({key}) => {
 if(key === "Enter")
 {
  if(elem.value != "" && elem.value >= 1)
  {
   document.getElementById("cefical").submit();
  }
  event.preventDefault();
  elem.focus();
  return false;
 }
});

document.getElementById("cefical").addEventListener("submit", function(event){
 let elem = document.getElementById("currentYear");
 if(elem.value != "" && elem.value >= 1)
 {
  return true;
 }
 event.preventDefault();
 elem.focus();
 return false;
})
</script>
</body>
</html>
